/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM fuelIApplication.idl
 */

#ifndef __gen_fuelIApplication_h__
#define __gen_fuelIApplication_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIVariant; /* forward declaration */

class nsIURI; /* forward declaration */

class nsIDOMHTMLDocument; /* forward declaration */

class fuelIPreference; /* forward declaration */

class fuelIBookmarkFolder; /* forward declaration */

class fuelIBrowserTab; /* forward declaration */


/* starting interface:    fuelIConsole */
#define FUELICONSOLE_IID_STR "ae8482e0-aa5a-11db-abbd-0800200c9a66"

#define FUELICONSOLE_IID \
  {0xae8482e0, 0xaa5a, 0x11db, \
    { 0xab, 0xbd, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

/**
 * Interface that gives simplified access to the console
 */
class NS_NO_VTABLE fuelIConsole : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELICONSOLE_IID)

  /**
   * Sends a given string to the console.
   * @param   aMsg
   *          The text to send to the console
   */
  /* void log (in AString aMsg); */
  NS_IMETHOD Log(const nsAString & aMsg) = 0;

  /**
   * Opens the error console window. The console window
   * is focused if already open.
   */
  /* void open (); */
  NS_IMETHOD Open(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIConsole, FUELICONSOLE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELICONSOLE \
  NS_IMETHOD Log(const nsAString & aMsg); \
  NS_IMETHOD Open(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELICONSOLE(_to) \
  NS_IMETHOD Log(const nsAString & aMsg) { return _to Log(aMsg); } \
  NS_IMETHOD Open(void) { return _to Open(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELICONSOLE(_to) \
  NS_IMETHOD Log(const nsAString & aMsg) { return !_to ? NS_ERROR_NULL_POINTER : _to->Log(aMsg); } \
  NS_IMETHOD Open(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Open(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIConsole
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELICONSOLE

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIConsole)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void log (in AString aMsg); */
NS_IMETHODIMP _MYCLASS_::Log(const nsAString & aMsg)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void open (); */
NS_IMETHODIMP _MYCLASS_::Open()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIEventItem */
#define FUELIEVENTITEM_IID_STR "05281820-ab62-11db-abbd-0800200c9a66"

#define FUELIEVENTITEM_IID \
  {0x05281820, 0xab62, 0x11db, \
    { 0xab, 0xbd, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

/**
 * Interface holds information about an event.
 */
class NS_NO_VTABLE fuelIEventItem : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIEVENTITEM_IID)

  /**
   * The name of the event
   */
  /* readonly attribute AString type; */
  NS_IMETHOD GetType(nsAString & aType) = 0;

  /**
   * Can hold extra details and data associated with the event. This
   * is optional and event specific. If the event does not send extra
   * details, this is null.
   */
  /* readonly attribute AString data; */
  NS_IMETHOD GetData(nsAString & aData) = 0;

  /**
   * Cancels the event if it is cancelable.
   */
  /* void preventDefault (); */
  NS_IMETHOD PreventDefault(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIEventItem, FUELIEVENTITEM_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIEVENTITEM \
  NS_IMETHOD GetType(nsAString & aType); \
  NS_IMETHOD GetData(nsAString & aData); \
  NS_IMETHOD PreventDefault(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIEVENTITEM(_to) \
  NS_IMETHOD GetType(nsAString & aType) { return _to GetType(aType); } \
  NS_IMETHOD GetData(nsAString & aData) { return _to GetData(aData); } \
  NS_IMETHOD PreventDefault(void) { return _to PreventDefault(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIEVENTITEM(_to) \
  NS_IMETHOD GetType(nsAString & aType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetType(aType); } \
  NS_IMETHOD GetData(nsAString & aData) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetData(aData); } \
  NS_IMETHOD PreventDefault(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->PreventDefault(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIEventItem
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIEVENTITEM

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIEventItem)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString type; */
NS_IMETHODIMP _MYCLASS_::GetType(nsAString & aType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString data; */
NS_IMETHODIMP _MYCLASS_::GetData(nsAString & aData)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void preventDefault (); */
NS_IMETHODIMP _MYCLASS_::PreventDefault()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIEventListener */
#define FUELIEVENTLISTENER_IID_STR "2dfe3a50-ab2f-11db-abbd-0800200c9a66"

#define FUELIEVENTLISTENER_IID \
  {0x2dfe3a50, 0xab2f, 0x11db, \
    { 0xab, 0xbd, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

/**
 * Interface used as a callback for listening to events.
 */
class NS_NO_VTABLE fuelIEventListener : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIEVENTLISTENER_IID)

  /**
   * This method is called whenever an event occurs of the type for which 
   * the fuelIEventListener interface was registered.
   *
   * @param   aEvent
   *          The fuelIEventItem associated with the event.
   */
  /* void handleEvent (in fuelIEventItem aEvent); */
  NS_IMETHOD HandleEvent(fuelIEventItem *aEvent) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIEventListener, FUELIEVENTLISTENER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIEVENTLISTENER \
  NS_IMETHOD HandleEvent(fuelIEventItem *aEvent); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIEVENTLISTENER(_to) \
  NS_IMETHOD HandleEvent(fuelIEventItem *aEvent) { return _to HandleEvent(aEvent); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIEVENTLISTENER(_to) \
  NS_IMETHOD HandleEvent(fuelIEventItem *aEvent) { return !_to ? NS_ERROR_NULL_POINTER : _to->HandleEvent(aEvent); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIEventListener
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIEVENTLISTENER

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIEventListener)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void handleEvent (in fuelIEventItem aEvent); */
NS_IMETHODIMP _MYCLASS_::HandleEvent(fuelIEventItem *aEvent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIEvents */
#define FUELIEVENTS_IID_STR "3a8ec9d0-ab19-11db-abbd-0800200c9a66"

#define FUELIEVENTS_IID \
  {0x3a8ec9d0, 0xab19, 0x11db, \
    { 0xab, 0xbd, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

/**
 * Interface for supporting custom events.
 */
class NS_NO_VTABLE fuelIEvents : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIEVENTS_IID)

  /**
   * Adds an event listener to the list. If multiple identical event listeners
   * are registered on the same event target with the same parameters the
   * duplicate instances are discarded. They do not cause the EventListener
   * to be called twice and since they are discarded they do not need to be
   * removed with the removeListener method.
   *
   * @param   aEvent
   *          The name of an event
   * @param   aListener
   *          The reference to a listener
   */
  /* void addListener (in AString aEvent, in fuelIEventListener aListener); */
  NS_IMETHOD AddListener(const nsAString & aEvent, fuelIEventListener *aListener) = 0;

  /**
   * Removes an event listener from the list. Calling remove
   * with arguments which do not identify any currently registered
   * event listener has no effect.
   * @param   aEvent
   *          The name of an event
   * @param   aListener
   *          The reference to a listener
   */
  /* void removeListener (in AString aEvent, in fuelIEventListener aListener); */
  NS_IMETHOD RemoveListener(const nsAString & aEvent, fuelIEventListener *aListener) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIEvents, FUELIEVENTS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIEVENTS \
  NS_IMETHOD AddListener(const nsAString & aEvent, fuelIEventListener *aListener); \
  NS_IMETHOD RemoveListener(const nsAString & aEvent, fuelIEventListener *aListener); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIEVENTS(_to) \
  NS_IMETHOD AddListener(const nsAString & aEvent, fuelIEventListener *aListener) { return _to AddListener(aEvent, aListener); } \
  NS_IMETHOD RemoveListener(const nsAString & aEvent, fuelIEventListener *aListener) { return _to RemoveListener(aEvent, aListener); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIEVENTS(_to) \
  NS_IMETHOD AddListener(const nsAString & aEvent, fuelIEventListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddListener(aEvent, aListener); } \
  NS_IMETHOD RemoveListener(const nsAString & aEvent, fuelIEventListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveListener(aEvent, aListener); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIEvents
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIEVENTS

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIEvents)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void addListener (in AString aEvent, in fuelIEventListener aListener); */
NS_IMETHODIMP _MYCLASS_::AddListener(const nsAString & aEvent, fuelIEventListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeListener (in AString aEvent, in fuelIEventListener aListener); */
NS_IMETHODIMP _MYCLASS_::RemoveListener(const nsAString & aEvent, fuelIEventListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIPreferenceBranch */
#define FUELIPREFERENCEBRANCH_IID_STR "ce697d40-aa5a-11db-abbd-0800200c9a66"

#define FUELIPREFERENCEBRANCH_IID \
  {0xce697d40, 0xaa5a, 0x11db, \
    { 0xab, 0xbd, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

/**
 * Interface for simplified access to preferences. The interface has a
 * predefined root preference branch. The root branch is set based on the
 * context of the owner. For example, an extension's preferences have a root
 * of "extensions.<extensionid>.", while the application level preferences
 * have an empty root. All preference "aName" parameters used in this interface
 * are relative to the root branch.
 */
class NS_NO_VTABLE fuelIPreferenceBranch : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIPREFERENCEBRANCH_IID)

  /**
   * The name of the branch root.
   */
  /* readonly attribute AString root; */
  NS_IMETHOD GetRoot(nsAString & aRoot) = 0;

  /**
   * Array of fuelIPreference listing all preferences in this branch.
   */
  /* readonly attribute nsIVariant all; */
  NS_IMETHOD GetAll(nsIVariant * *aAll) = 0;

  /**
   * The events object for the preferences
   * supports: "change"
   */
  /* readonly attribute fuelIEvents events; */
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) = 0;

  /**
   * Check to see if a preference exists.
   * @param   aName
   *          The name of preference
   * @returns true if the preference exists, false if not
   */
  /* boolean has (in AString aName); */
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval) = 0;

  /**
   * Gets an object representing a preference
   * @param   aName
   *          The name of preference
   * @returns a preference object, or null if the preference does not exist
   */
  /* fuelIPreference get (in AString aName); */
  NS_IMETHOD Get(const nsAString & aName, fuelIPreference **_retval) = 0;

  /**
   * Gets the value of a preference. Returns a default value if
   * the preference does not exist.
   * @param   aName
   *          The name of preference
   * @param   aDefaultValue
   *          The value to return if preference does not exist
   * @returns value of the preference or the given default value if preference
   *          does not exists.
   */
  /* nsIVariant getValue (in AString aName, in nsIVariant aDefaultValue); */
  NS_IMETHOD GetValue(const nsAString & aName, nsIVariant *aDefaultValue, nsIVariant **_retval) = 0;

  /**
   * Sets the value of a storage item with the given name.
   * @param   aName
   *          The name of an item
   * @param   aValue
   *          The value to assign to the item
   */
  /* void setValue (in AString aName, in nsIVariant aValue); */
  NS_IMETHOD SetValue(const nsAString & aName, nsIVariant *aValue) = 0;

  /**
   * Resets all preferences in a branch back to their default values.
   */
  /* void reset (); */
  NS_IMETHOD Reset(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIPreferenceBranch, FUELIPREFERENCEBRANCH_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIPREFERENCEBRANCH \
  NS_IMETHOD GetRoot(nsAString & aRoot); \
  NS_IMETHOD GetAll(nsIVariant * *aAll); \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents); \
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval); \
  NS_IMETHOD Get(const nsAString & aName, fuelIPreference **_retval); \
  NS_IMETHOD GetValue(const nsAString & aName, nsIVariant *aDefaultValue, nsIVariant **_retval); \
  NS_IMETHOD SetValue(const nsAString & aName, nsIVariant *aValue); \
  NS_IMETHOD Reset(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIPREFERENCEBRANCH(_to) \
  NS_IMETHOD GetRoot(nsAString & aRoot) { return _to GetRoot(aRoot); } \
  NS_IMETHOD GetAll(nsIVariant * *aAll) { return _to GetAll(aAll); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return _to GetEvents(aEvents); } \
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval) { return _to Has(aName, _retval); } \
  NS_IMETHOD Get(const nsAString & aName, fuelIPreference **_retval) { return _to Get(aName, _retval); } \
  NS_IMETHOD GetValue(const nsAString & aName, nsIVariant *aDefaultValue, nsIVariant **_retval) { return _to GetValue(aName, aDefaultValue, _retval); } \
  NS_IMETHOD SetValue(const nsAString & aName, nsIVariant *aValue) { return _to SetValue(aName, aValue); } \
  NS_IMETHOD Reset(void) { return _to Reset(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIPREFERENCEBRANCH(_to) \
  NS_IMETHOD GetRoot(nsAString & aRoot) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRoot(aRoot); } \
  NS_IMETHOD GetAll(nsIVariant * *aAll) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAll(aAll); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEvents(aEvents); } \
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Has(aName, _retval); } \
  NS_IMETHOD Get(const nsAString & aName, fuelIPreference **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Get(aName, _retval); } \
  NS_IMETHOD GetValue(const nsAString & aName, nsIVariant *aDefaultValue, nsIVariant **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetValue(aName, aDefaultValue, _retval); } \
  NS_IMETHOD SetValue(const nsAString & aName, nsIVariant *aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetValue(aName, aValue); } \
  NS_IMETHOD Reset(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Reset(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIPreferenceBranch
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIPREFERENCEBRANCH

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIPreferenceBranch)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString root; */
NS_IMETHODIMP _MYCLASS_::GetRoot(nsAString & aRoot)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIVariant all; */
NS_IMETHODIMP _MYCLASS_::GetAll(nsIVariant * *aAll)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIEvents events; */
NS_IMETHODIMP _MYCLASS_::GetEvents(fuelIEvents * *aEvents)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean has (in AString aName); */
NS_IMETHODIMP _MYCLASS_::Has(const nsAString & aName, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* fuelIPreference get (in AString aName); */
NS_IMETHODIMP _MYCLASS_::Get(const nsAString & aName, fuelIPreference **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIVariant getValue (in AString aName, in nsIVariant aDefaultValue); */
NS_IMETHODIMP _MYCLASS_::GetValue(const nsAString & aName, nsIVariant *aDefaultValue, nsIVariant **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setValue (in AString aName, in nsIVariant aValue); */
NS_IMETHODIMP _MYCLASS_::SetValue(const nsAString & aName, nsIVariant *aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void reset (); */
NS_IMETHODIMP _MYCLASS_::Reset()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIPreference */
#define FUELIPREFERENCE_IID_STR "2c7462e2-72c2-4473-9007-0e6ae71e23ca"

#define FUELIPREFERENCE_IID \
  {0x2c7462e2, 0x72c2, 0x4473, \
    { 0x90, 0x07, 0x0e, 0x6a, 0xe7, 0x1e, 0x23, 0xca }}

class NS_NO_VTABLE fuelIPreference : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIPREFERENCE_IID)

  /**
 * Interface for accessing a single preference. The data is not cached.
 * All reads access the current state of the preference.
 */
/**
   * The name of the preference.
   */
  /* readonly attribute AString name; */
  NS_IMETHOD GetName(nsAString & aName) = 0;

  /**
   * A string representing the type of preference (String, Boolean, or Number).
   */
  /* readonly attribute AString type; */
  NS_IMETHOD GetType(nsAString & aType) = 0;

  /**
   * Get/Set the value of the preference.
   */
  /* attribute nsIVariant value; */
  NS_IMETHOD GetValue(nsIVariant * *aValue) = 0;
  NS_IMETHOD SetValue(nsIVariant * aValue) = 0;

  /**
   * Get the locked state of the preference. Set to a boolean value to (un)lock it.
   */
  /* attribute boolean locked; */
  NS_IMETHOD GetLocked(PRBool *aLocked) = 0;
  NS_IMETHOD SetLocked(PRBool aLocked) = 0;

  /**
   * Check if a preference has been modified by the user, or not.
   */
  /* readonly attribute boolean modified; */
  NS_IMETHOD GetModified(PRBool *aModified) = 0;

  /**
   * The preference branch that contains this preference.
   */
  /* readonly attribute fuelIPreferenceBranch branch; */
  NS_IMETHOD GetBranch(fuelIPreferenceBranch * *aBranch) = 0;

  /**
   * The events object for this preference.
   * supports: "change"
   */
  /* readonly attribute fuelIEvents events; */
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) = 0;

  /**
   * Resets a preference back to its default values.
   */
  /* void reset (); */
  NS_IMETHOD Reset(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIPreference, FUELIPREFERENCE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIPREFERENCE \
  NS_IMETHOD GetName(nsAString & aName); \
  NS_IMETHOD GetType(nsAString & aType); \
  NS_IMETHOD GetValue(nsIVariant * *aValue); \
  NS_IMETHOD SetValue(nsIVariant * aValue); \
  NS_IMETHOD GetLocked(PRBool *aLocked); \
  NS_IMETHOD SetLocked(PRBool aLocked); \
  NS_IMETHOD GetModified(PRBool *aModified); \
  NS_IMETHOD GetBranch(fuelIPreferenceBranch * *aBranch); \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents); \
  NS_IMETHOD Reset(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIPREFERENCE(_to) \
  NS_IMETHOD GetName(nsAString & aName) { return _to GetName(aName); } \
  NS_IMETHOD GetType(nsAString & aType) { return _to GetType(aType); } \
  NS_IMETHOD GetValue(nsIVariant * *aValue) { return _to GetValue(aValue); } \
  NS_IMETHOD SetValue(nsIVariant * aValue) { return _to SetValue(aValue); } \
  NS_IMETHOD GetLocked(PRBool *aLocked) { return _to GetLocked(aLocked); } \
  NS_IMETHOD SetLocked(PRBool aLocked) { return _to SetLocked(aLocked); } \
  NS_IMETHOD GetModified(PRBool *aModified) { return _to GetModified(aModified); } \
  NS_IMETHOD GetBranch(fuelIPreferenceBranch * *aBranch) { return _to GetBranch(aBranch); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return _to GetEvents(aEvents); } \
  NS_IMETHOD Reset(void) { return _to Reset(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIPREFERENCE(_to) \
  NS_IMETHOD GetName(nsAString & aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetName(aName); } \
  NS_IMETHOD GetType(nsAString & aType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetType(aType); } \
  NS_IMETHOD GetValue(nsIVariant * *aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetValue(aValue); } \
  NS_IMETHOD SetValue(nsIVariant * aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetValue(aValue); } \
  NS_IMETHOD GetLocked(PRBool *aLocked) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLocked(aLocked); } \
  NS_IMETHOD SetLocked(PRBool aLocked) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLocked(aLocked); } \
  NS_IMETHOD GetModified(PRBool *aModified) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetModified(aModified); } \
  NS_IMETHOD GetBranch(fuelIPreferenceBranch * *aBranch) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBranch(aBranch); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEvents(aEvents); } \
  NS_IMETHOD Reset(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Reset(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIPreference
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIPREFERENCE

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIPreference)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString name; */
NS_IMETHODIMP _MYCLASS_::GetName(nsAString & aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString type; */
NS_IMETHODIMP _MYCLASS_::GetType(nsAString & aType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIVariant value; */
NS_IMETHODIMP _MYCLASS_::GetValue(nsIVariant * *aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetValue(nsIVariant * aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean locked; */
NS_IMETHODIMP _MYCLASS_::GetLocked(PRBool *aLocked)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetLocked(PRBool aLocked)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean modified; */
NS_IMETHODIMP _MYCLASS_::GetModified(PRBool *aModified)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIPreferenceBranch branch; */
NS_IMETHODIMP _MYCLASS_::GetBranch(fuelIPreferenceBranch * *aBranch)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIEvents events; */
NS_IMETHODIMP _MYCLASS_::GetEvents(fuelIEvents * *aEvents)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void reset (); */
NS_IMETHODIMP _MYCLASS_::Reset()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelISessionStorage */
#define FUELISESSIONSTORAGE_IID_STR "0787ac44-29b9-4889-b97f-13573aec6971"

#define FUELISESSIONSTORAGE_IID \
  {0x0787ac44, 0x29b9, 0x4889, \
    { 0xb9, 0x7f, 0x13, 0x57, 0x3a, 0xec, 0x69, 0x71 }}

/**
 * Interface representing a simple storage system
 */
class NS_NO_VTABLE fuelISessionStorage : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELISESSIONSTORAGE_IID)

  /**
   * The events object for the storage
   * supports: "change"
   */
  /* readonly attribute fuelIEvents events; */
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) = 0;

  /**
   * Determines if a storage item exists with the given name.
   * @param   aName
   *          The name of an item
   * @returns true if an item exists with the given name,
   *          false otherwise.
   */
  /* boolean has (in AString aName); */
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval) = 0;

  /**
   * Sets the value of a storage item with the given name.
   * @param   aName
   *          The name of an item
   * @param   aValue
   *          The value to assign to the item
   */
  /* void set (in AString aName, in nsIVariant aValue); */
  NS_IMETHOD Set(const nsAString & aName, nsIVariant *aValue) = 0;

  /**
   * Gets the value of a storage item with the given name. Returns a
   * default value if the item does not exist.
   * @param   aName
   *          The name of an item
   * @param   aDefaultValue
   *          The value to return if no item exists with the given name
   * @returns value of the item or the given default value if no item
   *          exists with the given name.
   */
  /* nsIVariant get (in AString aName, in nsIVariant aDefaultValue); */
  NS_IMETHOD Get(const nsAString & aName, nsIVariant *aDefaultValue, nsIVariant **_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelISessionStorage, FUELISESSIONSTORAGE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELISESSIONSTORAGE \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents); \
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval); \
  NS_IMETHOD Set(const nsAString & aName, nsIVariant *aValue); \
  NS_IMETHOD Get(const nsAString & aName, nsIVariant *aDefaultValue, nsIVariant **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELISESSIONSTORAGE(_to) \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return _to GetEvents(aEvents); } \
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval) { return _to Has(aName, _retval); } \
  NS_IMETHOD Set(const nsAString & aName, nsIVariant *aValue) { return _to Set(aName, aValue); } \
  NS_IMETHOD Get(const nsAString & aName, nsIVariant *aDefaultValue, nsIVariant **_retval) { return _to Get(aName, aDefaultValue, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELISESSIONSTORAGE(_to) \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEvents(aEvents); } \
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Has(aName, _retval); } \
  NS_IMETHOD Set(const nsAString & aName, nsIVariant *aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->Set(aName, aValue); } \
  NS_IMETHOD Get(const nsAString & aName, nsIVariant *aDefaultValue, nsIVariant **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Get(aName, aDefaultValue, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelISessionStorage
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELISESSIONSTORAGE

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelISessionStorage)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute fuelIEvents events; */
NS_IMETHODIMP _MYCLASS_::GetEvents(fuelIEvents * *aEvents)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean has (in AString aName); */
NS_IMETHODIMP _MYCLASS_::Has(const nsAString & aName, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void set (in AString aName, in nsIVariant aValue); */
NS_IMETHODIMP _MYCLASS_::Set(const nsAString & aName, nsIVariant *aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIVariant get (in AString aName, in nsIVariant aDefaultValue); */
NS_IMETHODIMP _MYCLASS_::Get(const nsAString & aName, nsIVariant *aDefaultValue, nsIVariant **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIExtension */
#define FUELIEXTENSION_IID_STR "ea563b60-aa5a-11db-abbd-0800200c9a66"

#define FUELIEXTENSION_IID \
  {0xea563b60, 0xaa5a, 0x11db, \
    { 0xab, 0xbd, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

/**
 * Interface representing an extension
 */
class NS_NO_VTABLE fuelIExtension : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIEXTENSION_IID)

  /**
   * The id of the extension.
   */
  /* readonly attribute AString id; */
  NS_IMETHOD GetId(nsAString & aId) = 0;

  /**
   * The name of the extension.
   */
  /* readonly attribute AString name; */
  NS_IMETHOD GetName(nsAString & aName) = 0;

  /**
   * The version number of the extension.
   */
  /* readonly attribute AString version; */
  NS_IMETHOD GetVersion(nsAString & aVersion) = 0;

  /**
   * Indicates whether this is the extension's first run after install
   */
  /* readonly attribute boolean firstRun; */
  NS_IMETHOD GetFirstRun(PRBool *aFirstRun) = 0;

  /**
   * The preferences object for the extension. Defaults to the
   * "extensions.<extensionid>." branch.
   */
  /* readonly attribute fuelIPreferenceBranch prefs; */
  NS_IMETHOD GetPrefs(fuelIPreferenceBranch * *aPrefs) = 0;

  /**
   * The storage object for the extension.
   */
  /* readonly attribute fuelISessionStorage storage; */
  NS_IMETHOD GetStorage(fuelISessionStorage * *aStorage) = 0;

  /**
   * The events object for the extension.
   * supports: "uninstall"
   */
  /* readonly attribute fuelIEvents events; */
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIExtension, FUELIEXTENSION_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIEXTENSION \
  NS_IMETHOD GetId(nsAString & aId); \
  NS_IMETHOD GetName(nsAString & aName); \
  NS_IMETHOD GetVersion(nsAString & aVersion); \
  NS_IMETHOD GetFirstRun(PRBool *aFirstRun); \
  NS_IMETHOD GetPrefs(fuelIPreferenceBranch * *aPrefs); \
  NS_IMETHOD GetStorage(fuelISessionStorage * *aStorage); \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIEXTENSION(_to) \
  NS_IMETHOD GetId(nsAString & aId) { return _to GetId(aId); } \
  NS_IMETHOD GetName(nsAString & aName) { return _to GetName(aName); } \
  NS_IMETHOD GetVersion(nsAString & aVersion) { return _to GetVersion(aVersion); } \
  NS_IMETHOD GetFirstRun(PRBool *aFirstRun) { return _to GetFirstRun(aFirstRun); } \
  NS_IMETHOD GetPrefs(fuelIPreferenceBranch * *aPrefs) { return _to GetPrefs(aPrefs); } \
  NS_IMETHOD GetStorage(fuelISessionStorage * *aStorage) { return _to GetStorage(aStorage); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return _to GetEvents(aEvents); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIEXTENSION(_to) \
  NS_IMETHOD GetId(nsAString & aId) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetId(aId); } \
  NS_IMETHOD GetName(nsAString & aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetName(aName); } \
  NS_IMETHOD GetVersion(nsAString & aVersion) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetVersion(aVersion); } \
  NS_IMETHOD GetFirstRun(PRBool *aFirstRun) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFirstRun(aFirstRun); } \
  NS_IMETHOD GetPrefs(fuelIPreferenceBranch * *aPrefs) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPrefs(aPrefs); } \
  NS_IMETHOD GetStorage(fuelISessionStorage * *aStorage) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStorage(aStorage); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEvents(aEvents); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIExtension
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIEXTENSION

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIExtension)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString id; */
NS_IMETHODIMP _MYCLASS_::GetId(nsAString & aId)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString name; */
NS_IMETHODIMP _MYCLASS_::GetName(nsAString & aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString version; */
NS_IMETHODIMP _MYCLASS_::GetVersion(nsAString & aVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean firstRun; */
NS_IMETHODIMP _MYCLASS_::GetFirstRun(PRBool *aFirstRun)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIPreferenceBranch prefs; */
NS_IMETHODIMP _MYCLASS_::GetPrefs(fuelIPreferenceBranch * *aPrefs)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelISessionStorage storage; */
NS_IMETHODIMP _MYCLASS_::GetStorage(fuelISessionStorage * *aStorage)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIEvents events; */
NS_IMETHODIMP _MYCLASS_::GetEvents(fuelIEvents * *aEvents)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIExtensions */
#define FUELIEXTENSIONS_IID_STR "de281930-aa5a-11db-abbd-0800200c9a66"

#define FUELIEXTENSIONS_IID \
  {0xde281930, 0xaa5a, 0x11db, \
    { 0xab, 0xbd, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

/**
 * Interface representing a list of all installed extensions
 */
class NS_NO_VTABLE fuelIExtensions : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIEXTENSIONS_IID)

  /**
   * Array of fuelIExtension listing all extensions in the application.
   */
  /* readonly attribute nsIVariant all; */
  NS_IMETHOD GetAll(nsIVariant * *aAll) = 0;

  /**
   * Determines if an extension exists with the given id.
   * @param   aId
   *          The id of an extension
   * @returns true if an extension exists with the given id,
   *          false otherwise.
   */
  /* boolean has (in AString aId); */
  NS_IMETHOD Has(const nsAString & aId, PRBool *_retval) = 0;

  /**
   * Gets a fuelIExtension object for an extension.
   * @param   aId
   *          The id of an extension
   * @returns An extension object or null if no extension exists
   *          with the given id.
   */
  /* fuelIExtension get (in AString aId); */
  NS_IMETHOD Get(const nsAString & aId, fuelIExtension **_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIExtensions, FUELIEXTENSIONS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIEXTENSIONS \
  NS_IMETHOD GetAll(nsIVariant * *aAll); \
  NS_IMETHOD Has(const nsAString & aId, PRBool *_retval); \
  NS_IMETHOD Get(const nsAString & aId, fuelIExtension **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIEXTENSIONS(_to) \
  NS_IMETHOD GetAll(nsIVariant * *aAll) { return _to GetAll(aAll); } \
  NS_IMETHOD Has(const nsAString & aId, PRBool *_retval) { return _to Has(aId, _retval); } \
  NS_IMETHOD Get(const nsAString & aId, fuelIExtension **_retval) { return _to Get(aId, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIEXTENSIONS(_to) \
  NS_IMETHOD GetAll(nsIVariant * *aAll) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAll(aAll); } \
  NS_IMETHOD Has(const nsAString & aId, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Has(aId, _retval); } \
  NS_IMETHOD Get(const nsAString & aId, fuelIExtension **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Get(aId, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIExtensions
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIEXTENSIONS

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIExtensions)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute nsIVariant all; */
NS_IMETHODIMP _MYCLASS_::GetAll(nsIVariant * *aAll)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean has (in AString aId); */
NS_IMETHODIMP _MYCLASS_::Has(const nsAString & aId, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* fuelIExtension get (in AString aId); */
NS_IMETHODIMP _MYCLASS_::Get(const nsAString & aId, fuelIExtension **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIAnnotations */
#define FUELIANNOTATIONS_IID_STR "335c9292-91a1-4ca0-ad0b-07d5f63ed6cd"

#define FUELIANNOTATIONS_IID \
  {0x335c9292, 0x91a1, 0x4ca0, \
    { 0xad, 0x0b, 0x07, 0xd5, 0xf6, 0x3e, 0xd6, 0xcd }}

/**
 * Interface representing a collection of annotations associated
 * with a bookmark or bookmark folder.
 */
class NS_NO_VTABLE fuelIAnnotations : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIANNOTATIONS_IID)

  /**
   * Array of the annotation names associated with the owning item
   */
  /* readonly attribute nsIVariant names; */
  NS_IMETHOD GetNames(nsIVariant * *aNames) = 0;

  /**
   * Determines if an annotation exists with the given name.
   * @param   aName
   *          The name of the annotation
   * @returns true if an annotation exists with the given name,
   *          false otherwise.
   */
  /* boolean has (in AString aName); */
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval) = 0;

  /**
   * Gets the value of an annotation with the given name.
   * @param   aName
   *          The name of the annotation
   * @returns A variant containing the value of the annotation. Supports
   *          string, boolean and number.
   */
  /* nsIVariant get (in AString aName); */
  NS_IMETHOD Get(const nsAString & aName, nsIVariant **_retval) = 0;

  /**
   * Sets the value of an annotation with the given name.
   * @param   aName
   *          The name of the annotation
   * @param   aValue
   *          The new value of the annotation. Supports string, boolean
   *          and number
   * @param   aExpiration
   *          The expiration policy for the annotation.
   *          See nsIAnnotationService.
   */
  /* void set (in AString aName, in nsIVariant aValue, in PRInt32 aExpiration); */
  NS_IMETHOD Set(const nsAString & aName, nsIVariant *aValue, PRInt32 aExpiration) = 0;

  /**
   * Removes the named annotation from the owner item.
   * @param   aName
   *          The name of annotation.
   */
  /* void remove (in AString aName); */
  NS_IMETHOD Remove(const nsAString & aName) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIAnnotations, FUELIANNOTATIONS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIANNOTATIONS \
  NS_IMETHOD GetNames(nsIVariant * *aNames); \
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval); \
  NS_IMETHOD Get(const nsAString & aName, nsIVariant **_retval); \
  NS_IMETHOD Set(const nsAString & aName, nsIVariant *aValue, PRInt32 aExpiration); \
  NS_IMETHOD Remove(const nsAString & aName); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIANNOTATIONS(_to) \
  NS_IMETHOD GetNames(nsIVariant * *aNames) { return _to GetNames(aNames); } \
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval) { return _to Has(aName, _retval); } \
  NS_IMETHOD Get(const nsAString & aName, nsIVariant **_retval) { return _to Get(aName, _retval); } \
  NS_IMETHOD Set(const nsAString & aName, nsIVariant *aValue, PRInt32 aExpiration) { return _to Set(aName, aValue, aExpiration); } \
  NS_IMETHOD Remove(const nsAString & aName) { return _to Remove(aName); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIANNOTATIONS(_to) \
  NS_IMETHOD GetNames(nsIVariant * *aNames) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNames(aNames); } \
  NS_IMETHOD Has(const nsAString & aName, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Has(aName, _retval); } \
  NS_IMETHOD Get(const nsAString & aName, nsIVariant **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Get(aName, _retval); } \
  NS_IMETHOD Set(const nsAString & aName, nsIVariant *aValue, PRInt32 aExpiration) { return !_to ? NS_ERROR_NULL_POINTER : _to->Set(aName, aValue, aExpiration); } \
  NS_IMETHOD Remove(const nsAString & aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->Remove(aName); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIAnnotations
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIANNOTATIONS

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIAnnotations)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute nsIVariant names; */
NS_IMETHODIMP _MYCLASS_::GetNames(nsIVariant * *aNames)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean has (in AString aName); */
NS_IMETHODIMP _MYCLASS_::Has(const nsAString & aName, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIVariant get (in AString aName); */
NS_IMETHODIMP _MYCLASS_::Get(const nsAString & aName, nsIVariant **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void set (in AString aName, in nsIVariant aValue, in PRInt32 aExpiration); */
NS_IMETHODIMP _MYCLASS_::Set(const nsAString & aName, nsIVariant *aValue, PRInt32 aExpiration)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void remove (in AString aName); */
NS_IMETHODIMP _MYCLASS_::Remove(const nsAString & aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIBookmark */
#define FUELIBOOKMARK_IID_STR "808585b6-7568-4b26-8c62-545221bf2b8c"

#define FUELIBOOKMARK_IID \
  {0x808585b6, 0x7568, 0x4b26, \
    { 0x8c, 0x62, 0x54, 0x52, 0x21, 0xbf, 0x2b, 0x8c }}

/**
 * Interface representing a bookmark item.
 */
class NS_NO_VTABLE fuelIBookmark : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIBOOKMARK_IID)

  /**
   * The id of the bookmark.
   */
  /* readonly attribute long long id; */
  NS_IMETHOD GetId(PRInt64 *aId) = 0;

  /**
   * The title of the bookmark.
   */
  /* attribute AString title; */
  NS_IMETHOD GetTitle(nsAString & aTitle) = 0;
  NS_IMETHOD SetTitle(const nsAString & aTitle) = 0;

  /**
   * The uri of the bookmark.
   */
  /* attribute nsIURI uri; */
  NS_IMETHOD GetUri(nsIURI * *aUri) = 0;
  NS_IMETHOD SetUri(nsIURI * aUri) = 0;

  /**
   * The description of the bookmark.
   */
  /* attribute AString description; */
  NS_IMETHOD GetDescription(nsAString & aDescription) = 0;
  NS_IMETHOD SetDescription(const nsAString & aDescription) = 0;

  /**
   * The keyword associated with the bookmark.
   */
  /* attribute AString keyword; */
  NS_IMETHOD GetKeyword(nsAString & aKeyword) = 0;
  NS_IMETHOD SetKeyword(const nsAString & aKeyword) = 0;

  /**
   * The type of the bookmark.
   * values: "bookmark", "separator"
   */
  /* readonly attribute AString type; */
  NS_IMETHOD GetType(nsAString & aType) = 0;

  /**
   * The parent folder of the bookmark.
   */
  /* attribute fuelIBookmarkFolder parent; */
  NS_IMETHOD GetParent(fuelIBookmarkFolder * *aParent) = 0;
  NS_IMETHOD SetParent(fuelIBookmarkFolder * aParent) = 0;

  /**
   * The annotations object for the bookmark.
   */
  /* readonly attribute fuelIAnnotations annotations; */
  NS_IMETHOD GetAnnotations(fuelIAnnotations * *aAnnotations) = 0;

  /**
   * The events object for the bookmark.
   * supports: "remove", "change", "visit", "move"
   */
  /* readonly attribute fuelIEvents events; */
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) = 0;

  /**
   * Removes the item from the parent folder. Used to
   * delete a bookmark or separator
   */
  /* void remove (); */
  NS_IMETHOD Remove(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIBookmark, FUELIBOOKMARK_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIBOOKMARK \
  NS_IMETHOD GetId(PRInt64 *aId); \
  NS_IMETHOD GetTitle(nsAString & aTitle); \
  NS_IMETHOD SetTitle(const nsAString & aTitle); \
  NS_IMETHOD GetUri(nsIURI * *aUri); \
  NS_IMETHOD SetUri(nsIURI * aUri); \
  NS_IMETHOD GetDescription(nsAString & aDescription); \
  NS_IMETHOD SetDescription(const nsAString & aDescription); \
  NS_IMETHOD GetKeyword(nsAString & aKeyword); \
  NS_IMETHOD SetKeyword(const nsAString & aKeyword); \
  NS_IMETHOD GetType(nsAString & aType); \
  NS_IMETHOD GetParent(fuelIBookmarkFolder * *aParent); \
  NS_IMETHOD SetParent(fuelIBookmarkFolder * aParent); \
  NS_IMETHOD GetAnnotations(fuelIAnnotations * *aAnnotations); \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents); \
  NS_IMETHOD Remove(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIBOOKMARK(_to) \
  NS_IMETHOD GetId(PRInt64 *aId) { return _to GetId(aId); } \
  NS_IMETHOD GetTitle(nsAString & aTitle) { return _to GetTitle(aTitle); } \
  NS_IMETHOD SetTitle(const nsAString & aTitle) { return _to SetTitle(aTitle); } \
  NS_IMETHOD GetUri(nsIURI * *aUri) { return _to GetUri(aUri); } \
  NS_IMETHOD SetUri(nsIURI * aUri) { return _to SetUri(aUri); } \
  NS_IMETHOD GetDescription(nsAString & aDescription) { return _to GetDescription(aDescription); } \
  NS_IMETHOD SetDescription(const nsAString & aDescription) { return _to SetDescription(aDescription); } \
  NS_IMETHOD GetKeyword(nsAString & aKeyword) { return _to GetKeyword(aKeyword); } \
  NS_IMETHOD SetKeyword(const nsAString & aKeyword) { return _to SetKeyword(aKeyword); } \
  NS_IMETHOD GetType(nsAString & aType) { return _to GetType(aType); } \
  NS_IMETHOD GetParent(fuelIBookmarkFolder * *aParent) { return _to GetParent(aParent); } \
  NS_IMETHOD SetParent(fuelIBookmarkFolder * aParent) { return _to SetParent(aParent); } \
  NS_IMETHOD GetAnnotations(fuelIAnnotations * *aAnnotations) { return _to GetAnnotations(aAnnotations); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return _to GetEvents(aEvents); } \
  NS_IMETHOD Remove(void) { return _to Remove(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIBOOKMARK(_to) \
  NS_IMETHOD GetId(PRInt64 *aId) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetId(aId); } \
  NS_IMETHOD GetTitle(nsAString & aTitle) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTitle(aTitle); } \
  NS_IMETHOD SetTitle(const nsAString & aTitle) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetTitle(aTitle); } \
  NS_IMETHOD GetUri(nsIURI * *aUri) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUri(aUri); } \
  NS_IMETHOD SetUri(nsIURI * aUri) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetUri(aUri); } \
  NS_IMETHOD GetDescription(nsAString & aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDescription(aDescription); } \
  NS_IMETHOD SetDescription(const nsAString & aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDescription(aDescription); } \
  NS_IMETHOD GetKeyword(nsAString & aKeyword) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetKeyword(aKeyword); } \
  NS_IMETHOD SetKeyword(const nsAString & aKeyword) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetKeyword(aKeyword); } \
  NS_IMETHOD GetType(nsAString & aType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetType(aType); } \
  NS_IMETHOD GetParent(fuelIBookmarkFolder * *aParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetParent(aParent); } \
  NS_IMETHOD SetParent(fuelIBookmarkFolder * aParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetParent(aParent); } \
  NS_IMETHOD GetAnnotations(fuelIAnnotations * *aAnnotations) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAnnotations(aAnnotations); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEvents(aEvents); } \
  NS_IMETHOD Remove(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Remove(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIBookmark
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIBOOKMARK

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIBookmark)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute long long id; */
NS_IMETHODIMP _MYCLASS_::GetId(PRInt64 *aId)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString title; */
NS_IMETHODIMP _MYCLASS_::GetTitle(nsAString & aTitle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetTitle(const nsAString & aTitle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIURI uri; */
NS_IMETHODIMP _MYCLASS_::GetUri(nsIURI * *aUri)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetUri(nsIURI * aUri)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString description; */
NS_IMETHODIMP _MYCLASS_::GetDescription(nsAString & aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetDescription(const nsAString & aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString keyword; */
NS_IMETHODIMP _MYCLASS_::GetKeyword(nsAString & aKeyword)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetKeyword(const nsAString & aKeyword)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString type; */
NS_IMETHODIMP _MYCLASS_::GetType(nsAString & aType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute fuelIBookmarkFolder parent; */
NS_IMETHODIMP _MYCLASS_::GetParent(fuelIBookmarkFolder * *aParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetParent(fuelIBookmarkFolder * aParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIAnnotations annotations; */
NS_IMETHODIMP _MYCLASS_::GetAnnotations(fuelIAnnotations * *aAnnotations)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIEvents events; */
NS_IMETHODIMP _MYCLASS_::GetEvents(fuelIEvents * *aEvents)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void remove (); */
NS_IMETHODIMP _MYCLASS_::Remove()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIBookmarkFolder */
#define FUELIBOOKMARKFOLDER_IID_STR "9f42fe20-52de-4a55-8632-a459c7716aa0"

#define FUELIBOOKMARKFOLDER_IID \
  {0x9f42fe20, 0x52de, 0x4a55, \
    { 0x86, 0x32, 0xa4, 0x59, 0xc7, 0x71, 0x6a, 0xa0 }}

class NS_NO_VTABLE fuelIBookmarkFolder : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIBOOKMARKFOLDER_IID)

  /**
 * Interface representing a bookmark folder. Folders
 * can hold bookmarks, separators and other folders.
 */
/**
   * The id of the folder.
   */
  /* readonly attribute long long id; */
  NS_IMETHOD GetId(PRInt64 *aId) = 0;

  /**
   * The title of the folder.
   */
  /* attribute AString title; */
  NS_IMETHOD GetTitle(nsAString & aTitle) = 0;
  NS_IMETHOD SetTitle(const nsAString & aTitle) = 0;

  /**
   * The description of the folder.
   */
  /* attribute AString description; */
  NS_IMETHOD GetDescription(nsAString & aDescription) = 0;
  NS_IMETHOD SetDescription(const nsAString & aDescription) = 0;

  /**
   * The type of the folder.
   * values: "folder"
   */
  /* readonly attribute AString type; */
  NS_IMETHOD GetType(nsAString & aType) = 0;

  /**
   * The parent folder of the folder.
   */
  /* attribute fuelIBookmarkFolder parent; */
  NS_IMETHOD GetParent(fuelIBookmarkFolder * *aParent) = 0;
  NS_IMETHOD SetParent(fuelIBookmarkFolder * aParent) = 0;

  /**
   * The annotations object for the folder.
   */
  /* readonly attribute fuelIAnnotations annotations; */
  NS_IMETHOD GetAnnotations(fuelIAnnotations * *aAnnotations) = 0;

  /**
   * The events object for the folder.
   * supports: "add", "addchild", "remove", "removechild", "change", "move"
   */
  /* readonly attribute fuelIEvents events; */
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) = 0;

  /**
   * Array of all bookmarks, separators and folders contained
   * in this folder.
   */
  /* readonly attribute nsIVariant children; */
  NS_IMETHOD GetChildren(nsIVariant * *aChildren) = 0;

  /**
   * Adds a new child bookmark to this folder.
   * @param   aTitle
   *          The title of bookmark.
   * @param   aURI
   *          The uri of bookmark.
   */
  /* fuelIBookmark addBookmark (in AString aTitle, in nsIURI aURI); */
  NS_IMETHOD AddBookmark(const nsAString & aTitle, nsIURI *aURI, fuelIBookmark **_retval) = 0;

  /**
   * Adds a new child separator to this folder.
   */
  /* fuelIBookmark addSeparator (); */
  NS_IMETHOD AddSeparator(fuelIBookmark **_retval) = 0;

  /**
   * Adds a new child folder to this folder.
   * @param   aTitle
   *          The title of folder.
   */
  /* fuelIBookmarkFolder addFolder (in AString aTitle); */
  NS_IMETHOD AddFolder(const nsAString & aTitle, fuelIBookmarkFolder **_retval) = 0;

  /**
   * Removes the folder from the parent folder.
   */
  /* void remove (); */
  NS_IMETHOD Remove(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIBookmarkFolder, FUELIBOOKMARKFOLDER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIBOOKMARKFOLDER \
  NS_IMETHOD GetId(PRInt64 *aId); \
  NS_IMETHOD GetTitle(nsAString & aTitle); \
  NS_IMETHOD SetTitle(const nsAString & aTitle); \
  NS_IMETHOD GetDescription(nsAString & aDescription); \
  NS_IMETHOD SetDescription(const nsAString & aDescription); \
  NS_IMETHOD GetType(nsAString & aType); \
  NS_IMETHOD GetParent(fuelIBookmarkFolder * *aParent); \
  NS_IMETHOD SetParent(fuelIBookmarkFolder * aParent); \
  NS_IMETHOD GetAnnotations(fuelIAnnotations * *aAnnotations); \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents); \
  NS_IMETHOD GetChildren(nsIVariant * *aChildren); \
  NS_IMETHOD AddBookmark(const nsAString & aTitle, nsIURI *aURI, fuelIBookmark **_retval); \
  NS_IMETHOD AddSeparator(fuelIBookmark **_retval); \
  NS_IMETHOD AddFolder(const nsAString & aTitle, fuelIBookmarkFolder **_retval); \
  NS_IMETHOD Remove(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIBOOKMARKFOLDER(_to) \
  NS_IMETHOD GetId(PRInt64 *aId) { return _to GetId(aId); } \
  NS_IMETHOD GetTitle(nsAString & aTitle) { return _to GetTitle(aTitle); } \
  NS_IMETHOD SetTitle(const nsAString & aTitle) { return _to SetTitle(aTitle); } \
  NS_IMETHOD GetDescription(nsAString & aDescription) { return _to GetDescription(aDescription); } \
  NS_IMETHOD SetDescription(const nsAString & aDescription) { return _to SetDescription(aDescription); } \
  NS_IMETHOD GetType(nsAString & aType) { return _to GetType(aType); } \
  NS_IMETHOD GetParent(fuelIBookmarkFolder * *aParent) { return _to GetParent(aParent); } \
  NS_IMETHOD SetParent(fuelIBookmarkFolder * aParent) { return _to SetParent(aParent); } \
  NS_IMETHOD GetAnnotations(fuelIAnnotations * *aAnnotations) { return _to GetAnnotations(aAnnotations); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return _to GetEvents(aEvents); } \
  NS_IMETHOD GetChildren(nsIVariant * *aChildren) { return _to GetChildren(aChildren); } \
  NS_IMETHOD AddBookmark(const nsAString & aTitle, nsIURI *aURI, fuelIBookmark **_retval) { return _to AddBookmark(aTitle, aURI, _retval); } \
  NS_IMETHOD AddSeparator(fuelIBookmark **_retval) { return _to AddSeparator(_retval); } \
  NS_IMETHOD AddFolder(const nsAString & aTitle, fuelIBookmarkFolder **_retval) { return _to AddFolder(aTitle, _retval); } \
  NS_IMETHOD Remove(void) { return _to Remove(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIBOOKMARKFOLDER(_to) \
  NS_IMETHOD GetId(PRInt64 *aId) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetId(aId); } \
  NS_IMETHOD GetTitle(nsAString & aTitle) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTitle(aTitle); } \
  NS_IMETHOD SetTitle(const nsAString & aTitle) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetTitle(aTitle); } \
  NS_IMETHOD GetDescription(nsAString & aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDescription(aDescription); } \
  NS_IMETHOD SetDescription(const nsAString & aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDescription(aDescription); } \
  NS_IMETHOD GetType(nsAString & aType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetType(aType); } \
  NS_IMETHOD GetParent(fuelIBookmarkFolder * *aParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetParent(aParent); } \
  NS_IMETHOD SetParent(fuelIBookmarkFolder * aParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetParent(aParent); } \
  NS_IMETHOD GetAnnotations(fuelIAnnotations * *aAnnotations) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAnnotations(aAnnotations); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEvents(aEvents); } \
  NS_IMETHOD GetChildren(nsIVariant * *aChildren) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetChildren(aChildren); } \
  NS_IMETHOD AddBookmark(const nsAString & aTitle, nsIURI *aURI, fuelIBookmark **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddBookmark(aTitle, aURI, _retval); } \
  NS_IMETHOD AddSeparator(fuelIBookmark **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddSeparator(_retval); } \
  NS_IMETHOD AddFolder(const nsAString & aTitle, fuelIBookmarkFolder **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddFolder(aTitle, _retval); } \
  NS_IMETHOD Remove(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Remove(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIBookmarkFolder
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIBOOKMARKFOLDER

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIBookmarkFolder)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute long long id; */
NS_IMETHODIMP _MYCLASS_::GetId(PRInt64 *aId)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString title; */
NS_IMETHODIMP _MYCLASS_::GetTitle(nsAString & aTitle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetTitle(const nsAString & aTitle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString description; */
NS_IMETHODIMP _MYCLASS_::GetDescription(nsAString & aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetDescription(const nsAString & aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString type; */
NS_IMETHODIMP _MYCLASS_::GetType(nsAString & aType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute fuelIBookmarkFolder parent; */
NS_IMETHODIMP _MYCLASS_::GetParent(fuelIBookmarkFolder * *aParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetParent(fuelIBookmarkFolder * aParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIAnnotations annotations; */
NS_IMETHODIMP _MYCLASS_::GetAnnotations(fuelIAnnotations * *aAnnotations)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIEvents events; */
NS_IMETHODIMP _MYCLASS_::GetEvents(fuelIEvents * *aEvents)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIVariant children; */
NS_IMETHODIMP _MYCLASS_::GetChildren(nsIVariant * *aChildren)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* fuelIBookmark addBookmark (in AString aTitle, in nsIURI aURI); */
NS_IMETHODIMP _MYCLASS_::AddBookmark(const nsAString & aTitle, nsIURI *aURI, fuelIBookmark **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* fuelIBookmark addSeparator (); */
NS_IMETHODIMP _MYCLASS_::AddSeparator(fuelIBookmark **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* fuelIBookmarkFolder addFolder (in AString aTitle); */
NS_IMETHODIMP _MYCLASS_::AddFolder(const nsAString & aTitle, fuelIBookmarkFolder **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void remove (); */
NS_IMETHODIMP _MYCLASS_::Remove()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIWindow */
#define FUELIWINDOW_IID_STR "207edb28-eb5e-424e-a862-b0e97c8de866"

#define FUELIWINDOW_IID \
  {0x207edb28, 0xeb5e, 0x424e, \
    { 0xa8, 0x62, 0xb0, 0xe9, 0x7c, 0x8d, 0xe8, 0x66 }}

/**
 * Interface representing a browser window.
 */
class NS_NO_VTABLE fuelIWindow : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIWINDOW_IID)

  /**
   * A collection of browser tabs within the browser window.
   */
  /* readonly attribute nsIVariant tabs; */
  NS_IMETHOD GetTabs(nsIVariant * *aTabs) = 0;

  /**
   * The currently-active tab within the browser window.
   */
  /* readonly attribute fuelIBrowserTab activeTab; */
  NS_IMETHOD GetActiveTab(fuelIBrowserTab * *aActiveTab) = 0;

  /**
   * Open a new browser tab, pointing to the specified URI.
   * @param   aURI
   *          The uri to open the browser tab to
   */
  /* fuelIBrowserTab open (in nsIURI aURI); */
  NS_IMETHOD Open(nsIURI *aURI, fuelIBrowserTab **_retval) = 0;

  /**
   * The events object for the browser window.
   * supports: "TabOpen", "TabClose", "TabMove", "TabSelect"
   */
  /* readonly attribute fuelIEvents events; */
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIWindow, FUELIWINDOW_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIWINDOW \
  NS_IMETHOD GetTabs(nsIVariant * *aTabs); \
  NS_IMETHOD GetActiveTab(fuelIBrowserTab * *aActiveTab); \
  NS_IMETHOD Open(nsIURI *aURI, fuelIBrowserTab **_retval); \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIWINDOW(_to) \
  NS_IMETHOD GetTabs(nsIVariant * *aTabs) { return _to GetTabs(aTabs); } \
  NS_IMETHOD GetActiveTab(fuelIBrowserTab * *aActiveTab) { return _to GetActiveTab(aActiveTab); } \
  NS_IMETHOD Open(nsIURI *aURI, fuelIBrowserTab **_retval) { return _to Open(aURI, _retval); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return _to GetEvents(aEvents); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIWINDOW(_to) \
  NS_IMETHOD GetTabs(nsIVariant * *aTabs) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTabs(aTabs); } \
  NS_IMETHOD GetActiveTab(fuelIBrowserTab * *aActiveTab) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetActiveTab(aActiveTab); } \
  NS_IMETHOD Open(nsIURI *aURI, fuelIBrowserTab **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Open(aURI, _retval); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEvents(aEvents); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIWindow
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIWINDOW

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIWindow)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute nsIVariant tabs; */
NS_IMETHODIMP _MYCLASS_::GetTabs(nsIVariant * *aTabs)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIBrowserTab activeTab; */
NS_IMETHODIMP _MYCLASS_::GetActiveTab(fuelIBrowserTab * *aActiveTab)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* fuelIBrowserTab open (in nsIURI aURI); */
NS_IMETHODIMP _MYCLASS_::Open(nsIURI *aURI, fuelIBrowserTab **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIEvents events; */
NS_IMETHODIMP _MYCLASS_::GetEvents(fuelIEvents * *aEvents)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIBrowserTab */
#define FUELIBROWSERTAB_IID_STR "3073ceff-777c-41ce-9ace-ab37268147c1"

#define FUELIBROWSERTAB_IID \
  {0x3073ceff, 0x777c, 0x41ce, \
    { 0x9a, 0xce, 0xab, 0x37, 0x26, 0x81, 0x47, 0xc1 }}

class NS_NO_VTABLE fuelIBrowserTab : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIBROWSERTAB_IID)

  /**
 * Interface representing a browser tab.
 */
/**
   * The current uri of this tab.
   */
  /* readonly attribute nsIURI uri; */
  NS_IMETHOD GetUri(nsIURI * *aUri) = 0;

  /**
   * The current index of this tab in the browser window.
   */
  /* readonly attribute PRInt32 index; */
  NS_IMETHOD GetIndex(PRInt32 *aIndex) = 0;

  /**
   * The browser window that is holding the tab.
   */
  /* readonly attribute fuelIWindow window; */
  NS_IMETHOD GetWindow(fuelIWindow * *aWindow) = 0;

  /**
   * The content document of the browser tab.
   */
  /* readonly attribute nsIDOMHTMLDocument document; */
  NS_IMETHOD GetDocument(nsIDOMHTMLDocument * *aDocument) = 0;

  /**
   * The events object for the browser tab.
   * supports: "load"
   */
  /* readonly attribute fuelIEvents events; */
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) = 0;

  /**
   * Load a new URI into this browser tab.
   * @param   aURI
   *          The uri to load into the browser tab
   */
  /* void load (in nsIURI aURI); */
  NS_IMETHOD Load(nsIURI *aURI) = 0;

  /**
   * Give focus to this browser tab, and bring it to the front.
   */
  /* void focus (); */
  NS_IMETHOD Focus(void) = 0;

  /**
   * Close the browser tab. This may not actually close the tab
   * as script may abort the close operation.
   */
  /* void close (); */
  NS_IMETHOD Close(void) = 0;

  /**
   * Moves this browser tab before another browser tab within the window.
   * @param   aBefore
   *          The tab before which the target tab will be moved
   */
  /* void moveBefore (in fuelIBrowserTab aBefore); */
  NS_IMETHOD MoveBefore(fuelIBrowserTab *aBefore) = 0;

  /**
   * Move this browser tab to the last tab within the window.
   */
  /* void moveToEnd (); */
  NS_IMETHOD MoveToEnd(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIBrowserTab, FUELIBROWSERTAB_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIBROWSERTAB \
  NS_IMETHOD GetUri(nsIURI * *aUri); \
  NS_IMETHOD GetIndex(PRInt32 *aIndex); \
  NS_IMETHOD GetWindow(fuelIWindow * *aWindow); \
  NS_IMETHOD GetDocument(nsIDOMHTMLDocument * *aDocument); \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents); \
  NS_IMETHOD Load(nsIURI *aURI); \
  NS_IMETHOD Focus(void); \
  NS_IMETHOD Close(void); \
  NS_IMETHOD MoveBefore(fuelIBrowserTab *aBefore); \
  NS_IMETHOD MoveToEnd(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIBROWSERTAB(_to) \
  NS_IMETHOD GetUri(nsIURI * *aUri) { return _to GetUri(aUri); } \
  NS_IMETHOD GetIndex(PRInt32 *aIndex) { return _to GetIndex(aIndex); } \
  NS_IMETHOD GetWindow(fuelIWindow * *aWindow) { return _to GetWindow(aWindow); } \
  NS_IMETHOD GetDocument(nsIDOMHTMLDocument * *aDocument) { return _to GetDocument(aDocument); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return _to GetEvents(aEvents); } \
  NS_IMETHOD Load(nsIURI *aURI) { return _to Load(aURI); } \
  NS_IMETHOD Focus(void) { return _to Focus(); } \
  NS_IMETHOD Close(void) { return _to Close(); } \
  NS_IMETHOD MoveBefore(fuelIBrowserTab *aBefore) { return _to MoveBefore(aBefore); } \
  NS_IMETHOD MoveToEnd(void) { return _to MoveToEnd(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIBROWSERTAB(_to) \
  NS_IMETHOD GetUri(nsIURI * *aUri) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUri(aUri); } \
  NS_IMETHOD GetIndex(PRInt32 *aIndex) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIndex(aIndex); } \
  NS_IMETHOD GetWindow(fuelIWindow * *aWindow) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetWindow(aWindow); } \
  NS_IMETHOD GetDocument(nsIDOMHTMLDocument * *aDocument) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDocument(aDocument); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEvents(aEvents); } \
  NS_IMETHOD Load(nsIURI *aURI) { return !_to ? NS_ERROR_NULL_POINTER : _to->Load(aURI); } \
  NS_IMETHOD Focus(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Focus(); } \
  NS_IMETHOD Close(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Close(); } \
  NS_IMETHOD MoveBefore(fuelIBrowserTab *aBefore) { return !_to ? NS_ERROR_NULL_POINTER : _to->MoveBefore(aBefore); } \
  NS_IMETHOD MoveToEnd(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->MoveToEnd(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIBrowserTab
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIBROWSERTAB

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIBrowserTab)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute nsIURI uri; */
NS_IMETHODIMP _MYCLASS_::GetUri(nsIURI * *aUri)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute PRInt32 index; */
NS_IMETHODIMP _MYCLASS_::GetIndex(PRInt32 *aIndex)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIWindow window; */
NS_IMETHODIMP _MYCLASS_::GetWindow(fuelIWindow * *aWindow)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMHTMLDocument document; */
NS_IMETHODIMP _MYCLASS_::GetDocument(nsIDOMHTMLDocument * *aDocument)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIEvents events; */
NS_IMETHODIMP _MYCLASS_::GetEvents(fuelIEvents * *aEvents)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void load (in nsIURI aURI); */
NS_IMETHODIMP _MYCLASS_::Load(nsIURI *aURI)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void focus (); */
NS_IMETHODIMP _MYCLASS_::Focus()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void close (); */
NS_IMETHODIMP _MYCLASS_::Close()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void moveBefore (in fuelIBrowserTab aBefore); */
NS_IMETHODIMP _MYCLASS_::MoveBefore(fuelIBrowserTab *aBefore)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void moveToEnd (); */
NS_IMETHODIMP _MYCLASS_::MoveToEnd()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    fuelIApplication */
#define FUELIAPPLICATION_IID_STR "fe74cf80-aa2d-11db-abbd-0800200c9a66"

#define FUELIAPPLICATION_IID \
  {0xfe74cf80, 0xaa2d, 0x11db, \
    { 0xab, 0xbd, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

/**
 * Interface for managing and accessing the applications systems
 */
class NS_NO_VTABLE fuelIApplication : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FUELIAPPLICATION_IID)

  /**
   * The id of the application.
   */
  /* readonly attribute AString id; */
  NS_IMETHOD GetId(nsAString & aId) = 0;

  /**
   * The name of the application.
   */
  /* readonly attribute AString name; */
  NS_IMETHOD GetName(nsAString & aName) = 0;

  /**
   * The version number of the application.
   */
  /* readonly attribute AString version; */
  NS_IMETHOD GetVersion(nsAString & aVersion) = 0;

  /**
   * The console object for the application.
   */
  /* readonly attribute fuelIConsole console; */
  NS_IMETHOD GetConsole(fuelIConsole * *aConsole) = 0;

  /**
   * The extensions object for the application. Contains a list
   * of all installed extensions.
   */
  /* readonly attribute fuelIExtensions extensions; */
  NS_IMETHOD GetExtensions(fuelIExtensions * *aExtensions) = 0;

  /**
   * The preferences object for the application. Defaults to an empty
   * root branch.
   */
  /* readonly attribute fuelIPreferenceBranch prefs; */
  NS_IMETHOD GetPrefs(fuelIPreferenceBranch * *aPrefs) = 0;

  /**
   * The storage object for the application.
   */
  /* readonly attribute fuelISessionStorage storage; */
  NS_IMETHOD GetStorage(fuelISessionStorage * *aStorage) = 0;

  /**
   * The events object for the application.
   * supports: "load", "ready", "quit", "unload"
   */
  /* readonly attribute fuelIEvents events; */
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) = 0;

  /**
   * The root bookmarks object for the application.
   */
  /* readonly attribute fuelIBookmarkFolder bookmarks; */
  NS_IMETHOD GetBookmarks(fuelIBookmarkFolder * *aBookmarks) = 0;

  /**
   * An array of browser windows within the application.
   */
  /* readonly attribute nsIVariant windows; */
  NS_IMETHOD GetWindows(nsIVariant * *aWindows) = 0;

  /**
   * The currently active browser window.
   */
  /* readonly attribute fuelIWindow activeWindow; */
  NS_IMETHOD GetActiveWindow(fuelIWindow * *aActiveWindow) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(fuelIApplication, FUELIAPPLICATION_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FUELIAPPLICATION \
  NS_IMETHOD GetId(nsAString & aId); \
  NS_IMETHOD GetName(nsAString & aName); \
  NS_IMETHOD GetVersion(nsAString & aVersion); \
  NS_IMETHOD GetConsole(fuelIConsole * *aConsole); \
  NS_IMETHOD GetExtensions(fuelIExtensions * *aExtensions); \
  NS_IMETHOD GetPrefs(fuelIPreferenceBranch * *aPrefs); \
  NS_IMETHOD GetStorage(fuelISessionStorage * *aStorage); \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents); \
  NS_IMETHOD GetBookmarks(fuelIBookmarkFolder * *aBookmarks); \
  NS_IMETHOD GetWindows(nsIVariant * *aWindows); \
  NS_IMETHOD GetActiveWindow(fuelIWindow * *aActiveWindow); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FUELIAPPLICATION(_to) \
  NS_IMETHOD GetId(nsAString & aId) { return _to GetId(aId); } \
  NS_IMETHOD GetName(nsAString & aName) { return _to GetName(aName); } \
  NS_IMETHOD GetVersion(nsAString & aVersion) { return _to GetVersion(aVersion); } \
  NS_IMETHOD GetConsole(fuelIConsole * *aConsole) { return _to GetConsole(aConsole); } \
  NS_IMETHOD GetExtensions(fuelIExtensions * *aExtensions) { return _to GetExtensions(aExtensions); } \
  NS_IMETHOD GetPrefs(fuelIPreferenceBranch * *aPrefs) { return _to GetPrefs(aPrefs); } \
  NS_IMETHOD GetStorage(fuelISessionStorage * *aStorage) { return _to GetStorage(aStorage); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return _to GetEvents(aEvents); } \
  NS_IMETHOD GetBookmarks(fuelIBookmarkFolder * *aBookmarks) { return _to GetBookmarks(aBookmarks); } \
  NS_IMETHOD GetWindows(nsIVariant * *aWindows) { return _to GetWindows(aWindows); } \
  NS_IMETHOD GetActiveWindow(fuelIWindow * *aActiveWindow) { return _to GetActiveWindow(aActiveWindow); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FUELIAPPLICATION(_to) \
  NS_IMETHOD GetId(nsAString & aId) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetId(aId); } \
  NS_IMETHOD GetName(nsAString & aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetName(aName); } \
  NS_IMETHOD GetVersion(nsAString & aVersion) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetVersion(aVersion); } \
  NS_IMETHOD GetConsole(fuelIConsole * *aConsole) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetConsole(aConsole); } \
  NS_IMETHOD GetExtensions(fuelIExtensions * *aExtensions) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetExtensions(aExtensions); } \
  NS_IMETHOD GetPrefs(fuelIPreferenceBranch * *aPrefs) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPrefs(aPrefs); } \
  NS_IMETHOD GetStorage(fuelISessionStorage * *aStorage) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStorage(aStorage); } \
  NS_IMETHOD GetEvents(fuelIEvents * *aEvents) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEvents(aEvents); } \
  NS_IMETHOD GetBookmarks(fuelIBookmarkFolder * *aBookmarks) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBookmarks(aBookmarks); } \
  NS_IMETHOD GetWindows(nsIVariant * *aWindows) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetWindows(aWindows); } \
  NS_IMETHOD GetActiveWindow(fuelIWindow * *aActiveWindow) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetActiveWindow(aActiveWindow); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public fuelIApplication
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FUELIAPPLICATION

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, fuelIApplication)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString id; */
NS_IMETHODIMP _MYCLASS_::GetId(nsAString & aId)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString name; */
NS_IMETHODIMP _MYCLASS_::GetName(nsAString & aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString version; */
NS_IMETHODIMP _MYCLASS_::GetVersion(nsAString & aVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIConsole console; */
NS_IMETHODIMP _MYCLASS_::GetConsole(fuelIConsole * *aConsole)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIExtensions extensions; */
NS_IMETHODIMP _MYCLASS_::GetExtensions(fuelIExtensions * *aExtensions)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIPreferenceBranch prefs; */
NS_IMETHODIMP _MYCLASS_::GetPrefs(fuelIPreferenceBranch * *aPrefs)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelISessionStorage storage; */
NS_IMETHODIMP _MYCLASS_::GetStorage(fuelISessionStorage * *aStorage)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIEvents events; */
NS_IMETHODIMP _MYCLASS_::GetEvents(fuelIEvents * *aEvents)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIBookmarkFolder bookmarks; */
NS_IMETHODIMP _MYCLASS_::GetBookmarks(fuelIBookmarkFolder * *aBookmarks)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIVariant windows; */
NS_IMETHODIMP _MYCLASS_::GetWindows(nsIVariant * *aWindows)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute fuelIWindow activeWindow; */
NS_IMETHODIMP _MYCLASS_::GetActiveWindow(fuelIWindow * *aActiveWindow)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_fuelIApplication_h__ */
