/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIPlacesTransactionsService.idl
 */

#ifndef __gen_nsIPlacesTransactionsService_h__
#define __gen_nsIPlacesTransactionsService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIVariant; /* forward declaration */

class nsIURI; /* forward declaration */

class nsIMicrosummary; /* forward declaration */

class nsITransactionManager; /* forward declaration */

class nsITransaction; /* forward declaration */


/* starting interface:    nsIPlacesTransactionsService */
#define NS_IPLACESTRANSACTIONSSERVICE_IID_STR "2d176a73-a908-420b-8c5d-209a45997f45"

#define NS_IPLACESTRANSACTIONSSERVICE_IID \
  {0x2d176a73, 0xa908, 0x420b, \
    { 0x8c, 0x5d, 0x20, 0x9a, 0x45, 0x99, 0x7f, 0x45 }}

/**
 * nsIPlacesTransactionService is a service designed to handle
 * nsITransactions that correspond to changes in Places. It is here as a
 * service so that we can keep the transactions around without holding onto
 * the global scope of a js window.
 */
class NS_NO_VTABLE nsIPlacesTransactionsService : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPLACESTRANSACTIONSSERVICE_IID)

  /**
   * Performs a transaction.
   *
   * @param aTransaction
   *        a transaction object for a transaction
   */
  /* void commitTransaction (in nsITransaction aTransaction); */
  NS_IMETHOD CommitTransaction(nsITransaction *aTransaction) = 0;

  /**
   * Transaction for performing several Places Transactions in a single batch. 
   * 
   * @param aName
   *        title of the aggregate transactions
   * @param aTransactions
   *        an array of transactions to perform
   * @returns nsITransaction object
   */
  /* nsITransaction aggregateTransactions (in AString aName, in nsIVariant aTransactions); */
  NS_IMETHOD AggregateTransactions(const nsAString & aName, nsIVariant *aTransactions, nsITransaction **_retval) = 0;

  /**
   * Transaction for creating a new folder item.
   *
   * @param aName
   *        the name of the new folder
   * @param aContainer
   *        the identifier of the folder in which the new folder should be
   *        added.
   * @param [optional] aIndex
   *        the index of the item in aContainer, pass -1 or nothing to create
   *        the item at the end of aContainer.
   * @param [optional] aAnnotations
   *        the annotations to set for the new folder.
   * @param [optional] aChildItemsTransactions
   *        array of transactions for items to be created under the new folder.
   * @returns nsITransaction object
   */
  /* nsITransaction createFolder (in AString aName, in long long aContainer, [optional] in long long aIndex, [optional] in nsIVariant aAnnotations, [optional] in nsIVariant aChildItemsTransactions); */
  NS_IMETHOD CreateFolder(const nsAString & aName, PRInt64 aContainer, PRInt64 aIndex, nsIVariant *aAnnotations, nsIVariant *aChildItemsTransactions, nsITransaction **_retval) = 0;

  /**
   * Transaction for creating a new bookmark item
   *
   * @param aURI
   *        the uri of the new bookmark (nsIURI)
   * @param aContainer
   *        the identifier of the folder in which the bookmark should be added.
   * @param [optional] aIndex
   *        the index of the item in aContainer, pass -1 or nothing to create
   *        the item at the end of aContainer.
   * @param [optional] aTitle
   *        the title of the new bookmark.
   * @param [optional] aKeyword
   *        the keyword of the new bookmark.
   * @param [optional] aAnnotations
   *        the annotations to set for the new bookmark.
   * @param [optional] aChildTransactions
   *        child transactions to commit after creating the bookmark. Prefer
   *        using any of the arguments above if possible. In general, a child
   *        transations should be used only if the change it does has to be
   *        reverted manually when removing the bookmark item.
   *        a child transaction must support setting its bookmark-item
   *        identifier via an "id" js setter.
   * @returns nsITransaction object
   */
  /* nsITransaction createItem (in nsIURI aURI, in long long aContainer, [optional] in long long aIndex, [optional] in AString aTitle, [optional] in AString aKeyword, [optional] in nsIVariant aAnnotations, [optional] in nsIVariant aChildTransactions); */
  NS_IMETHOD CreateItem(nsIURI *aURI, PRInt64 aContainer, PRInt64 aIndex, const nsAString & aTitle, const nsAString & aKeyword, nsIVariant *aAnnotations, nsIVariant *aChildTransactions, nsITransaction **_retval) = 0;

  /**
   * Transaction for creating a new separator item
   *
   * @param aContainer
   *        the identifier of the folder in which the separator should be
   *        added.
   * @param [optional] aIndex
   *        the index of the item in aContainer, pass -1 or nothing to create
   *        the separator at the end of aContainer.
   * @returns nsITransaction object
   */
  /* nsITransaction createSeparator (in long long aContainer, [optional] in long long aIndex); */
  NS_IMETHOD CreateSeparator(PRInt64 aContainer, PRInt64 aIndex, nsITransaction **_retval) = 0;

  /**
   * Transaction for creating a new live-bookmark item.
   *
   * @see nsILivemarksService::createLivemark for documentation regarding the
   * first three arguments.
   *
   * @param aContainer
   *        the identifier of the folder in which the live-bookmark should be
   *        added.
   * @param [optional]  aIndex
   *        the index of the item in aContainer, pass -1 or nothing to create
   *        the item at the end of aContainer.
   * @param [optional] aAnnotations
   *        the annotations to set for the new live-bookmark.
   * @returns nsITransaction object
   */
  /* nsITransaction createLivemark (in nsIURI aFeedURI, in nsIURI aSiteURI, in AString aName, in long long aContainer, [optional] in long long aIndex, [optional] in nsIVariant aAnnotations); */
  NS_IMETHOD CreateLivemark(nsIURI *aFeedURI, nsIURI *aSiteURI, const nsAString & aName, PRInt64 aContainer, PRInt64 aIndex, nsIVariant *aAnnotations, nsITransaction **_retval) = 0;

  /**
   * Transaction for moving an Item.
   *
   * @param aItemId
   *        the id of the item to move
   * @param aNewContainer
   *        id of the new container to move to
   * @param aNewIndex
   *        index of the new position to move to
   * @returns nsITransaction object
   */
  /* nsITransaction moveItem (in long long aItemId, in long long aNewContainer, in long long aNewIndex); */
  NS_IMETHOD MoveItem(PRInt64 aItemId, PRInt64 aNewContainer, PRInt64 aNewIndex, nsITransaction **_retval) = 0;

  /**
   * Transaction for removing an Item
   *
   * @param aItemId
   *        id of the item to remove
   * @returns nsITransaction object
   */
  /* nsITransaction removeItem (in long long aItemId); */
  NS_IMETHOD RemoveItem(PRInt64 aItemId, nsITransaction **_retval) = 0;

  /**
   * Transaction for editting a bookmark's title.
   *
   * @param id
   *        id of the item to edit
   * @param newTitle
   *        new title for the item to edit
   * @returns nsITransaction object
   */
  /* nsITransaction editItemTitle (in long long id, in AString newTitle); */
  NS_IMETHOD EditItemTitle(PRInt64 id, const nsAString & newTitle, nsITransaction **_retval) = 0;

  /**
   * Transaction for editting a bookmark's uri.
   *
   * @param aBookmarkId
   *        id of the bookmark to edit
   * @param aNewURI
   *        new uri for the bookmark
   * @returns nsITransaction object
   */
  /* nsITransaction editBookmarkURI (in long long aBookmarkId, in nsIURI aNewURI); */
  NS_IMETHOD EditBookmarkURI(PRInt64 aBookmarkId, nsIURI *aNewURI, nsITransaction **_retval) = 0;

  /**
   * Transaction for setting/unsetting Load-in-sidebar annotation
   *
   * @param aBookmarkId
   *        id of the selected bookmark
   * @param aLoadInSidebar
   *        boolean value
   * @returns nsITransaction object
   */
  /* nsITransaction setLoadInSidebar (in long long aBookmarkId, in boolean aLoadInSidebar); */
  NS_IMETHOD SetLoadInSidebar(PRInt64 aBookmarkId, PRBool aLoadInSidebar, nsITransaction **_retval) = 0;

  /**
   * Transaction for editting a the description of a bookmark or a folder
   * 
   * @param aItemId
   *        id of the item to edit
   * @param aDescription
   *        new description
   * @returns nsITransaction object
   */
  /* nsITransaction editItemDescription (in long long aItemId, in AString aDescription); */
  NS_IMETHOD EditItemDescription(PRInt64 aItemId, const nsAString & aDescription, nsITransaction **_retval) = 0;

  /**
   * Transaction for editting a bookmark's keyword.
   *
   * @param id
   *        id of the bookmark to edit
   * @param newKeyword
   *        new keyword for the bookmark
   * @returns nsITransaction object
   */
  /* nsITransaction editBookmarkKeyword (in long long id, in AString newKeyword); */
  NS_IMETHOD EditBookmarkKeyword(PRInt64 id, const nsAString & newKeyword, nsITransaction **_retval) = 0;

  /**
   * Transaction for editting the post data associated with a URI
   *
   * @param aURI
   *        uri to edit
   * @param aPostData
   *        post data
   * @returns nsITransaction object
   */
  /* nsITransaction editURIPostData (in nsIURI aURI, in AString aPostData); */
  NS_IMETHOD EditURIPostData(nsIURI *aURI, const nsAString & aPostData, nsITransaction **_retval) = 0;

  /**
   * Transaction for editting a live bookmark's site URI.
   *
   * @param aFolderId
   *        id of the livemark
   * @param aURI
   *        new site uri
   * @returns nsITransaction object
   */
  /* nsITransaction editLivemarkSiteURI (in long long aFolderId, in nsIURI aURI); */
  NS_IMETHOD EditLivemarkSiteURI(PRInt64 aFolderId, nsIURI *aURI, nsITransaction **_retval) = 0;

  /**
   * Transaction for editting a live bookmark's feed URI.
   *
   * @param folderId
   *        id of the livemark
   * @param uri
   *        new feed uri
   * @returns nsITransaction object
   */
  /* nsITransaction editLivemarkFeedURI (in long long folderId, in nsIURI uri); */
  NS_IMETHOD EditLivemarkFeedURI(PRInt64 folderId, nsIURI *uri, nsITransaction **_retval) = 0;

  /**
   * Transaction for editting a bookmark's microsummary.
   *
   * @param aItemId
   *        id of the bookmark to edit
   * @param aNewMicrosummary
   *        new microsummary for the bookmark
   * @returns nsITransaction object
   */
  /* nsITransaction editBookmarkMicrosummary (in long long aItemId, in nsIMicrosummary aNewMicrosummary); */
  NS_IMETHOD EditBookmarkMicrosummary(PRInt64 aItemId, nsIMicrosummary *aNewMicrosummary, nsITransaction **_retval) = 0;

  /**
   * Transaction for sorting a folder by name
   *
   * @param aFolderId
   *        id of the folder to sort
   * @oaram aFolderIndex
   *        index of the folder to sort
   * @returns nsITransaction object
   */
  /* nsITransaction sortFolderByName (in long long aFolderId, in long long aFolderIndex); */
  NS_IMETHOD SortFolderByName(PRInt64 aFolderId, PRInt64 aFolderIndex, nsITransaction **_retval) = 0;

  /**
   * Transaction for set the bookmarks toolbar folder.
   *
   * @param aFolderId
   *        id of the folder to set as toolbar folder
   * @returns nsITransaction object
   */
  /* nsITransaction setBookmarksToolbar (in long long aFolderId); */
  NS_IMETHOD SetBookmarksToolbar(PRInt64 aFolderId, nsITransaction **_retval) = 0;

  /**
   * A reference to the transaction manager
   */
  /* readonly attribute nsITransactionManager transactionManager; */
  NS_IMETHOD GetTransactionManager(nsITransactionManager * *aTransactionManager) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPlacesTransactionsService, NS_IPLACESTRANSACTIONSSERVICE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPLACESTRANSACTIONSSERVICE \
  NS_IMETHOD CommitTransaction(nsITransaction *aTransaction); \
  NS_IMETHOD AggregateTransactions(const nsAString & aName, nsIVariant *aTransactions, nsITransaction **_retval); \
  NS_IMETHOD CreateFolder(const nsAString & aName, PRInt64 aContainer, PRInt64 aIndex, nsIVariant *aAnnotations, nsIVariant *aChildItemsTransactions, nsITransaction **_retval); \
  NS_IMETHOD CreateItem(nsIURI *aURI, PRInt64 aContainer, PRInt64 aIndex, const nsAString & aTitle, const nsAString & aKeyword, nsIVariant *aAnnotations, nsIVariant *aChildTransactions, nsITransaction **_retval); \
  NS_IMETHOD CreateSeparator(PRInt64 aContainer, PRInt64 aIndex, nsITransaction **_retval); \
  NS_IMETHOD CreateLivemark(nsIURI *aFeedURI, nsIURI *aSiteURI, const nsAString & aName, PRInt64 aContainer, PRInt64 aIndex, nsIVariant *aAnnotations, nsITransaction **_retval); \
  NS_IMETHOD MoveItem(PRInt64 aItemId, PRInt64 aNewContainer, PRInt64 aNewIndex, nsITransaction **_retval); \
  NS_IMETHOD RemoveItem(PRInt64 aItemId, nsITransaction **_retval); \
  NS_IMETHOD EditItemTitle(PRInt64 id, const nsAString & newTitle, nsITransaction **_retval); \
  NS_IMETHOD EditBookmarkURI(PRInt64 aBookmarkId, nsIURI *aNewURI, nsITransaction **_retval); \
  NS_IMETHOD SetLoadInSidebar(PRInt64 aBookmarkId, PRBool aLoadInSidebar, nsITransaction **_retval); \
  NS_IMETHOD EditItemDescription(PRInt64 aItemId, const nsAString & aDescription, nsITransaction **_retval); \
  NS_IMETHOD EditBookmarkKeyword(PRInt64 id, const nsAString & newKeyword, nsITransaction **_retval); \
  NS_IMETHOD EditURIPostData(nsIURI *aURI, const nsAString & aPostData, nsITransaction **_retval); \
  NS_IMETHOD EditLivemarkSiteURI(PRInt64 aFolderId, nsIURI *aURI, nsITransaction **_retval); \
  NS_IMETHOD EditLivemarkFeedURI(PRInt64 folderId, nsIURI *uri, nsITransaction **_retval); \
  NS_IMETHOD EditBookmarkMicrosummary(PRInt64 aItemId, nsIMicrosummary *aNewMicrosummary, nsITransaction **_retval); \
  NS_IMETHOD SortFolderByName(PRInt64 aFolderId, PRInt64 aFolderIndex, nsITransaction **_retval); \
  NS_IMETHOD SetBookmarksToolbar(PRInt64 aFolderId, nsITransaction **_retval); \
  NS_IMETHOD GetTransactionManager(nsITransactionManager * *aTransactionManager); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPLACESTRANSACTIONSSERVICE(_to) \
  NS_IMETHOD CommitTransaction(nsITransaction *aTransaction) { return _to CommitTransaction(aTransaction); } \
  NS_IMETHOD AggregateTransactions(const nsAString & aName, nsIVariant *aTransactions, nsITransaction **_retval) { return _to AggregateTransactions(aName, aTransactions, _retval); } \
  NS_IMETHOD CreateFolder(const nsAString & aName, PRInt64 aContainer, PRInt64 aIndex, nsIVariant *aAnnotations, nsIVariant *aChildItemsTransactions, nsITransaction **_retval) { return _to CreateFolder(aName, aContainer, aIndex, aAnnotations, aChildItemsTransactions, _retval); } \
  NS_IMETHOD CreateItem(nsIURI *aURI, PRInt64 aContainer, PRInt64 aIndex, const nsAString & aTitle, const nsAString & aKeyword, nsIVariant *aAnnotations, nsIVariant *aChildTransactions, nsITransaction **_retval) { return _to CreateItem(aURI, aContainer, aIndex, aTitle, aKeyword, aAnnotations, aChildTransactions, _retval); } \
  NS_IMETHOD CreateSeparator(PRInt64 aContainer, PRInt64 aIndex, nsITransaction **_retval) { return _to CreateSeparator(aContainer, aIndex, _retval); } \
  NS_IMETHOD CreateLivemark(nsIURI *aFeedURI, nsIURI *aSiteURI, const nsAString & aName, PRInt64 aContainer, PRInt64 aIndex, nsIVariant *aAnnotations, nsITransaction **_retval) { return _to CreateLivemark(aFeedURI, aSiteURI, aName, aContainer, aIndex, aAnnotations, _retval); } \
  NS_IMETHOD MoveItem(PRInt64 aItemId, PRInt64 aNewContainer, PRInt64 aNewIndex, nsITransaction **_retval) { return _to MoveItem(aItemId, aNewContainer, aNewIndex, _retval); } \
  NS_IMETHOD RemoveItem(PRInt64 aItemId, nsITransaction **_retval) { return _to RemoveItem(aItemId, _retval); } \
  NS_IMETHOD EditItemTitle(PRInt64 id, const nsAString & newTitle, nsITransaction **_retval) { return _to EditItemTitle(id, newTitle, _retval); } \
  NS_IMETHOD EditBookmarkURI(PRInt64 aBookmarkId, nsIURI *aNewURI, nsITransaction **_retval) { return _to EditBookmarkURI(aBookmarkId, aNewURI, _retval); } \
  NS_IMETHOD SetLoadInSidebar(PRInt64 aBookmarkId, PRBool aLoadInSidebar, nsITransaction **_retval) { return _to SetLoadInSidebar(aBookmarkId, aLoadInSidebar, _retval); } \
  NS_IMETHOD EditItemDescription(PRInt64 aItemId, const nsAString & aDescription, nsITransaction **_retval) { return _to EditItemDescription(aItemId, aDescription, _retval); } \
  NS_IMETHOD EditBookmarkKeyword(PRInt64 id, const nsAString & newKeyword, nsITransaction **_retval) { return _to EditBookmarkKeyword(id, newKeyword, _retval); } \
  NS_IMETHOD EditURIPostData(nsIURI *aURI, const nsAString & aPostData, nsITransaction **_retval) { return _to EditURIPostData(aURI, aPostData, _retval); } \
  NS_IMETHOD EditLivemarkSiteURI(PRInt64 aFolderId, nsIURI *aURI, nsITransaction **_retval) { return _to EditLivemarkSiteURI(aFolderId, aURI, _retval); } \
  NS_IMETHOD EditLivemarkFeedURI(PRInt64 folderId, nsIURI *uri, nsITransaction **_retval) { return _to EditLivemarkFeedURI(folderId, uri, _retval); } \
  NS_IMETHOD EditBookmarkMicrosummary(PRInt64 aItemId, nsIMicrosummary *aNewMicrosummary, nsITransaction **_retval) { return _to EditBookmarkMicrosummary(aItemId, aNewMicrosummary, _retval); } \
  NS_IMETHOD SortFolderByName(PRInt64 aFolderId, PRInt64 aFolderIndex, nsITransaction **_retval) { return _to SortFolderByName(aFolderId, aFolderIndex, _retval); } \
  NS_IMETHOD SetBookmarksToolbar(PRInt64 aFolderId, nsITransaction **_retval) { return _to SetBookmarksToolbar(aFolderId, _retval); } \
  NS_IMETHOD GetTransactionManager(nsITransactionManager * *aTransactionManager) { return _to GetTransactionManager(aTransactionManager); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPLACESTRANSACTIONSSERVICE(_to) \
  NS_IMETHOD CommitTransaction(nsITransaction *aTransaction) { return !_to ? NS_ERROR_NULL_POINTER : _to->CommitTransaction(aTransaction); } \
  NS_IMETHOD AggregateTransactions(const nsAString & aName, nsIVariant *aTransactions, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->AggregateTransactions(aName, aTransactions, _retval); } \
  NS_IMETHOD CreateFolder(const nsAString & aName, PRInt64 aContainer, PRInt64 aIndex, nsIVariant *aAnnotations, nsIVariant *aChildItemsTransactions, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateFolder(aName, aContainer, aIndex, aAnnotations, aChildItemsTransactions, _retval); } \
  NS_IMETHOD CreateItem(nsIURI *aURI, PRInt64 aContainer, PRInt64 aIndex, const nsAString & aTitle, const nsAString & aKeyword, nsIVariant *aAnnotations, nsIVariant *aChildTransactions, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateItem(aURI, aContainer, aIndex, aTitle, aKeyword, aAnnotations, aChildTransactions, _retval); } \
  NS_IMETHOD CreateSeparator(PRInt64 aContainer, PRInt64 aIndex, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateSeparator(aContainer, aIndex, _retval); } \
  NS_IMETHOD CreateLivemark(nsIURI *aFeedURI, nsIURI *aSiteURI, const nsAString & aName, PRInt64 aContainer, PRInt64 aIndex, nsIVariant *aAnnotations, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateLivemark(aFeedURI, aSiteURI, aName, aContainer, aIndex, aAnnotations, _retval); } \
  NS_IMETHOD MoveItem(PRInt64 aItemId, PRInt64 aNewContainer, PRInt64 aNewIndex, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->MoveItem(aItemId, aNewContainer, aNewIndex, _retval); } \
  NS_IMETHOD RemoveItem(PRInt64 aItemId, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveItem(aItemId, _retval); } \
  NS_IMETHOD EditItemTitle(PRInt64 id, const nsAString & newTitle, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EditItemTitle(id, newTitle, _retval); } \
  NS_IMETHOD EditBookmarkURI(PRInt64 aBookmarkId, nsIURI *aNewURI, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EditBookmarkURI(aBookmarkId, aNewURI, _retval); } \
  NS_IMETHOD SetLoadInSidebar(PRInt64 aBookmarkId, PRBool aLoadInSidebar, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLoadInSidebar(aBookmarkId, aLoadInSidebar, _retval); } \
  NS_IMETHOD EditItemDescription(PRInt64 aItemId, const nsAString & aDescription, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EditItemDescription(aItemId, aDescription, _retval); } \
  NS_IMETHOD EditBookmarkKeyword(PRInt64 id, const nsAString & newKeyword, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EditBookmarkKeyword(id, newKeyword, _retval); } \
  NS_IMETHOD EditURIPostData(nsIURI *aURI, const nsAString & aPostData, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EditURIPostData(aURI, aPostData, _retval); } \
  NS_IMETHOD EditLivemarkSiteURI(PRInt64 aFolderId, nsIURI *aURI, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EditLivemarkSiteURI(aFolderId, aURI, _retval); } \
  NS_IMETHOD EditLivemarkFeedURI(PRInt64 folderId, nsIURI *uri, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EditLivemarkFeedURI(folderId, uri, _retval); } \
  NS_IMETHOD EditBookmarkMicrosummary(PRInt64 aItemId, nsIMicrosummary *aNewMicrosummary, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EditBookmarkMicrosummary(aItemId, aNewMicrosummary, _retval); } \
  NS_IMETHOD SortFolderByName(PRInt64 aFolderId, PRInt64 aFolderIndex, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->SortFolderByName(aFolderId, aFolderIndex, _retval); } \
  NS_IMETHOD SetBookmarksToolbar(PRInt64 aFolderId, nsITransaction **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetBookmarksToolbar(aFolderId, _retval); } \
  NS_IMETHOD GetTransactionManager(nsITransactionManager * *aTransactionManager) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTransactionManager(aTransactionManager); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPlacesTransactionsService : public nsIPlacesTransactionsService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPLACESTRANSACTIONSSERVICE

  nsPlacesTransactionsService();

private:
  ~nsPlacesTransactionsService();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPlacesTransactionsService, nsIPlacesTransactionsService)

nsPlacesTransactionsService::nsPlacesTransactionsService()
{
  /* member initializers and constructor code */
}

nsPlacesTransactionsService::~nsPlacesTransactionsService()
{
  /* destructor code */
}

/* void commitTransaction (in nsITransaction aTransaction); */
NS_IMETHODIMP nsPlacesTransactionsService::CommitTransaction(nsITransaction *aTransaction)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction aggregateTransactions (in AString aName, in nsIVariant aTransactions); */
NS_IMETHODIMP nsPlacesTransactionsService::AggregateTransactions(const nsAString & aName, nsIVariant *aTransactions, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction createFolder (in AString aName, in long long aContainer, [optional] in long long aIndex, [optional] in nsIVariant aAnnotations, [optional] in nsIVariant aChildItemsTransactions); */
NS_IMETHODIMP nsPlacesTransactionsService::CreateFolder(const nsAString & aName, PRInt64 aContainer, PRInt64 aIndex, nsIVariant *aAnnotations, nsIVariant *aChildItemsTransactions, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction createItem (in nsIURI aURI, in long long aContainer, [optional] in long long aIndex, [optional] in AString aTitle, [optional] in AString aKeyword, [optional] in nsIVariant aAnnotations, [optional] in nsIVariant aChildTransactions); */
NS_IMETHODIMP nsPlacesTransactionsService::CreateItem(nsIURI *aURI, PRInt64 aContainer, PRInt64 aIndex, const nsAString & aTitle, const nsAString & aKeyword, nsIVariant *aAnnotations, nsIVariant *aChildTransactions, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction createSeparator (in long long aContainer, [optional] in long long aIndex); */
NS_IMETHODIMP nsPlacesTransactionsService::CreateSeparator(PRInt64 aContainer, PRInt64 aIndex, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction createLivemark (in nsIURI aFeedURI, in nsIURI aSiteURI, in AString aName, in long long aContainer, [optional] in long long aIndex, [optional] in nsIVariant aAnnotations); */
NS_IMETHODIMP nsPlacesTransactionsService::CreateLivemark(nsIURI *aFeedURI, nsIURI *aSiteURI, const nsAString & aName, PRInt64 aContainer, PRInt64 aIndex, nsIVariant *aAnnotations, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction moveItem (in long long aItemId, in long long aNewContainer, in long long aNewIndex); */
NS_IMETHODIMP nsPlacesTransactionsService::MoveItem(PRInt64 aItemId, PRInt64 aNewContainer, PRInt64 aNewIndex, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction removeItem (in long long aItemId); */
NS_IMETHODIMP nsPlacesTransactionsService::RemoveItem(PRInt64 aItemId, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction editItemTitle (in long long id, in AString newTitle); */
NS_IMETHODIMP nsPlacesTransactionsService::EditItemTitle(PRInt64 id, const nsAString & newTitle, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction editBookmarkURI (in long long aBookmarkId, in nsIURI aNewURI); */
NS_IMETHODIMP nsPlacesTransactionsService::EditBookmarkURI(PRInt64 aBookmarkId, nsIURI *aNewURI, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction setLoadInSidebar (in long long aBookmarkId, in boolean aLoadInSidebar); */
NS_IMETHODIMP nsPlacesTransactionsService::SetLoadInSidebar(PRInt64 aBookmarkId, PRBool aLoadInSidebar, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction editItemDescription (in long long aItemId, in AString aDescription); */
NS_IMETHODIMP nsPlacesTransactionsService::EditItemDescription(PRInt64 aItemId, const nsAString & aDescription, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction editBookmarkKeyword (in long long id, in AString newKeyword); */
NS_IMETHODIMP nsPlacesTransactionsService::EditBookmarkKeyword(PRInt64 id, const nsAString & newKeyword, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction editURIPostData (in nsIURI aURI, in AString aPostData); */
NS_IMETHODIMP nsPlacesTransactionsService::EditURIPostData(nsIURI *aURI, const nsAString & aPostData, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction editLivemarkSiteURI (in long long aFolderId, in nsIURI aURI); */
NS_IMETHODIMP nsPlacesTransactionsService::EditLivemarkSiteURI(PRInt64 aFolderId, nsIURI *aURI, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction editLivemarkFeedURI (in long long folderId, in nsIURI uri); */
NS_IMETHODIMP nsPlacesTransactionsService::EditLivemarkFeedURI(PRInt64 folderId, nsIURI *uri, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction editBookmarkMicrosummary (in long long aItemId, in nsIMicrosummary aNewMicrosummary); */
NS_IMETHODIMP nsPlacesTransactionsService::EditBookmarkMicrosummary(PRInt64 aItemId, nsIMicrosummary *aNewMicrosummary, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction sortFolderByName (in long long aFolderId, in long long aFolderIndex); */
NS_IMETHODIMP nsPlacesTransactionsService::SortFolderByName(PRInt64 aFolderId, PRInt64 aFolderIndex, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsITransaction setBookmarksToolbar (in long long aFolderId); */
NS_IMETHODIMP nsPlacesTransactionsService::SetBookmarksToolbar(PRInt64 aFolderId, nsITransaction **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsITransactionManager transactionManager; */
NS_IMETHODIMP nsPlacesTransactionsService::GetTransactionManager(nsITransactionManager * *aTransactionManager)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIPlacesTransactionsService_h__ */
