/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsITaggingService.idl
 */

#ifndef __gen_nsITaggingService_h__
#define __gen_nsITaggingService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIURI; /* forward declaration */

class nsIVariant; /* forward declaration */


/* starting interface:    nsITaggingService */
#define NS_ITAGGINGSERVICE_IID_STR "962bf94f-e719-4cf6-8967-74ff5d2020df"

#define NS_ITAGGINGSERVICE_IID \
  {0x962bf94f, 0xe719, 0x4cf6, \
    { 0x89, 0x67, 0x74, 0xff, 0x5d, 0x20, 0x20, 0xdf }}

class NS_NO_VTABLE nsITaggingService : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ITAGGINGSERVICE_IID)

  /**
   * Tags a URL with the given set of tags. Current tags set for the URL
   * persist. Tags in aTags which are already set for the given URL are
   * ignored.
   *
   * @param aURI
   *        the URL to tag.
   * @param aTags
   *        Array of tags to set for the given URL.
   */
  /* void tagURI (in nsIURI aURI, [array, size_is (aCount), const] in wstring aTags, in unsigned long aCount); */
  NS_IMETHOD TagURI(nsIURI *aURI, const PRUnichar **aTags, PRUint32 aCount) = 0;

  /**
   * Removes tags from a URL. Tags from aTags which are not set for the
   * given URL are ignored.
   *
   * @param aURI
   *        the URL to un-tag.
   * @param aTags
   *        Array of tags to unset.
   */
  /* void untagURI (in nsIURI aURI, [array, size_is (aCount), const] in wstring aTags, in unsigned long aCount); */
  NS_IMETHOD UntagURI(nsIURI *aURI, const PRUnichar **aTags, PRUint32 aCount) = 0;

  /**
   * Retrieves all URLs tagged with the given tag.
   *
   * @param aTag
   *        tag name
   * @returns Array of uris tagged with aTag.
   */
  /* nsIVariant getURIsForTag (in AString aTag); */
  NS_IMETHOD GetURIsForTag(const nsAString & aTag, nsIVariant **_retval) = 0;

  /**
   * Retrieves all tags set for the given URL.
   *
   * @param aURI
   *        a URL.
   * @returns array of tags (sorted by name).
   */
  /* nsIVariant getTagsForURI (in nsIURI aURI); */
  NS_IMETHOD GetTagsForURI(nsIURI *aURI, nsIVariant **_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsITaggingService, NS_ITAGGINGSERVICE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSITAGGINGSERVICE \
  NS_IMETHOD TagURI(nsIURI *aURI, const PRUnichar **aTags, PRUint32 aCount); \
  NS_IMETHOD UntagURI(nsIURI *aURI, const PRUnichar **aTags, PRUint32 aCount); \
  NS_IMETHOD GetURIsForTag(const nsAString & aTag, nsIVariant **_retval); \
  NS_IMETHOD GetTagsForURI(nsIURI *aURI, nsIVariant **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSITAGGINGSERVICE(_to) \
  NS_IMETHOD TagURI(nsIURI *aURI, const PRUnichar **aTags, PRUint32 aCount) { return _to TagURI(aURI, aTags, aCount); } \
  NS_IMETHOD UntagURI(nsIURI *aURI, const PRUnichar **aTags, PRUint32 aCount) { return _to UntagURI(aURI, aTags, aCount); } \
  NS_IMETHOD GetURIsForTag(const nsAString & aTag, nsIVariant **_retval) { return _to GetURIsForTag(aTag, _retval); } \
  NS_IMETHOD GetTagsForURI(nsIURI *aURI, nsIVariant **_retval) { return _to GetTagsForURI(aURI, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSITAGGINGSERVICE(_to) \
  NS_IMETHOD TagURI(nsIURI *aURI, const PRUnichar **aTags, PRUint32 aCount) { return !_to ? NS_ERROR_NULL_POINTER : _to->TagURI(aURI, aTags, aCount); } \
  NS_IMETHOD UntagURI(nsIURI *aURI, const PRUnichar **aTags, PRUint32 aCount) { return !_to ? NS_ERROR_NULL_POINTER : _to->UntagURI(aURI, aTags, aCount); } \
  NS_IMETHOD GetURIsForTag(const nsAString & aTag, nsIVariant **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetURIsForTag(aTag, _retval); } \
  NS_IMETHOD GetTagsForURI(nsIURI *aURI, nsIVariant **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTagsForURI(aURI, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsTaggingService : public nsITaggingService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSITAGGINGSERVICE

  nsTaggingService();

private:
  ~nsTaggingService();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsTaggingService, nsITaggingService)

nsTaggingService::nsTaggingService()
{
  /* member initializers and constructor code */
}

nsTaggingService::~nsTaggingService()
{
  /* destructor code */
}

/* void tagURI (in nsIURI aURI, [array, size_is (aCount), const] in wstring aTags, in unsigned long aCount); */
NS_IMETHODIMP nsTaggingService::TagURI(nsIURI *aURI, const PRUnichar **aTags, PRUint32 aCount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void untagURI (in nsIURI aURI, [array, size_is (aCount), const] in wstring aTags, in unsigned long aCount); */
NS_IMETHODIMP nsTaggingService::UntagURI(nsIURI *aURI, const PRUnichar **aTags, PRUint32 aCount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIVariant getURIsForTag (in AString aTag); */
NS_IMETHODIMP nsTaggingService::GetURIsForTag(const nsAString & aTag, nsIVariant **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIVariant getTagsForURI (in nsIURI aURI); */
NS_IMETHODIMP nsTaggingService::GetTagsForURI(nsIURI *aURI, nsIVariant **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsITaggingService_h__ */
